<template>
    <div class="layout-center">
        <div class="layout-border" style="background: rgb(255, 255, 255); padding: 24px">
            <a-typography-title :level="3" :style="{ marginBottom: 24 }">Login</a-typography-title>
            <a-form
                :label-col="{ style: { width: '30%', textAlign: 'left' } }"
                :wrapper-col="{ style: { width: '40%' } }"
                :model="formState"
                name="normal_login"
                class="login-form"
                @finish="onFinish"
                @finishFailed="onFinishFailed"
                :style="{ width: '400px' }"
            >
                <a-form-item label="Account" name="email" :rules="[{ required: true, message: 'Please input your username or email!' }]">
                    <a-input placeholder="username or email" v-model:value="formState.email">
                        <template #prefix>
                            <UserOutlined class="site-form-item-icon" />
                        </template>
                    </a-input>
                </a-form-item>

                <a-form-item label="Password" name="password" :rules="[{ required: true, message: 'Please input your password!' }]">
                    <a-input-password placeholder="password" v-model:value="formState.password">
                        <template #prefix>
                            <LockOutlined class="site-form-item-icon" />
                        </template>
                    </a-input-password>
                </a-form-item>

                <a-typography-text type="danger" v-if="errors">*{{ errors }}</a-typography-text>

                <div :style="{ display: 'flex', justifyContent: 'space-between', alignItems: 'flex-start', marginTop: '12px' }">
                    <a-form-item>
                        <a-button :disabled="disabled" type="primary" html-type="submit" class="login-form-button"> Log in </a-button>
                        Or
                        <a-typography-link underline href="/register">register now!</a-typography-link>
                    </a-form-item>
                    <a-typography-link underline :style="{ marginTop: '0.3rem' }" href="/forgot-password"> Forgot password? </a-typography-link>
                </div>
            </a-form>
        </div>
    </div>
</template>
<script lang="ts" setup>
import { reactive, computed } from "vue";
import { message } from "ant-design-vue";
import { UserOutlined, LockOutlined } from "@ant-design/icons-vue";

interface FormState {
    email: string;
    password: string;
    remember: boolean;
}
const formState = reactive<FormState>({
    email: "",
    password: "",
    remember: true,
});

// const api = useApiBridge();
// const { $axios } = useNuxtApp();
// this.$cookies.set("token", "123456", "1d" );

const router = useRouter();

const authStore = useAuthStore();
const userStore = useUserStore();
const { isLoaded } = storeToRefs(userStore)


const { $cookies } = useNuxtApp();

let errors = ref(null);


const onFinish = async (values: any) => {
    errors.value = null;
    isLoaded.value = true;
    try {
        await authStore.login(values);
        
        if($cookies.isKey('ACCESS_TOKEN')) {
            await authStore.getUser();
            await router.push("/");
        }
    } catch (error: any) { 
        console.log(error);
        
        message.error("Login failed!");
    } finally {
        isLoaded.value = false;
    }
};

const onFinishFailed = (errorInfo: any) => {
    console.log("Failed:", errorInfo);
};
const disabled = computed(() => {
    return !(formState.email && formState.password);
});
</script>

<style scoped>
#components-form-demo-normal-login .login-form {
    max-width: 300px;
}
#components-form-demo-normal-login .login-form-forgot {
    float: right;
}
#components-form-demo-normal-login .login-form-button {
    width: 100%;
}

.layout-center {
    display: flex;
    justify-content: center;
    align-items: center;
    height: 100vh;
}
</style>
